"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GrafanaAgentSessionSpanProcessor = void 0;
var agent_core_1 = require("@grafana/agent-core");
// adds grafana agent session id to every span
var GrafanaAgentSessionSpanProcessor = /** @class */ (function () {
    function GrafanaAgentSessionSpanProcessor(processor) {
        this.processor = processor;
    }
    GrafanaAgentSessionSpanProcessor.prototype.forceFlush = function () {
        return this.processor.forceFlush();
    };
    GrafanaAgentSessionSpanProcessor.prototype.onStart = function (span, parentContext) {
        var session = agent_core_1.agent.metas.value.session;
        if (session === null || session === void 0 ? void 0 : session.id) {
            span.attributes['session_id'] = session.id;
        }
        this.processor.onStart(span, parentContext);
    };
    GrafanaAgentSessionSpanProcessor.prototype.onEnd = function (span) {
        this.processor.onEnd(span);
    };
    GrafanaAgentSessionSpanProcessor.prototype.shutdown = function () {
        return this.processor.shutdown();
    };
    return GrafanaAgentSessionSpanProcessor;
}());
exports.GrafanaAgentSessionSpanProcessor = GrafanaAgentSessionSpanProcessor;
//# sourceMappingURL=sessionSpanProcessor.js.map